package ucot.input;

import java.net.URL;

import ucot.ModulePropertyInterface;

//TODO comment the general usage of this interface better
//and other related tasks that the interface has to do

/**
 * Interface for inputs used by UCOT core. Inputs are the modules that handle
 * reading data from given url and parsing usecases from it.
 * @author vevijopi
 *
 */
public interface InputInterface extends ModulePropertyInterface {
	
	// FIXME: kommentit pin vtua! ..nyt tarkkana Vesa;D
	/**
	 * Parses given usecase. Stores Parsed data to given ParsedData object.
	 * @param url Url where input is loaded from
	 * @return Steps read from the input
	 */
	public UseCaseCollection read(URL url) throws Exception;

	/**
	 * Test if this input can read file specified in url.
	 * @param url url of the file to try
	 * @return true if input can read the file
	 */
	public boolean canRead(URL url);

    /**
     * Returns inputs name as a String
     * @return String of inputs name
     */
    public String toString();
    
}


