package ucot.model.object;

import java.io.Serializable;

/**
 * This is attribute of an entity.
 * It is basically direct link with cardinal
 * information. 
 * 
 * @author pajumasu
 *
 */
public class Attribute implements Serializable {
	public static final long serialVersionUID = 82650222828672626L;
	
	String fromCardinal = "1";
	String toCardinal = "1";
	//String name = "";
	Entity entity;
	
	/**
	 * Creates new Attribute reference to given entity.
	 * @param entity The entity this attribute refers to.
	 */
	public Attribute(Entity entity){
		this.entity = entity;
		//this.name = entity.getName();
	}
	
	/**
	 * Get the entity this attribute refers to.
	 * @return The entity referred.
	 */
	public Entity getEntity(){
		return entity;
	}
	
	/**
	 * Sets the entity this attribute refers to.
	 * @param entity The entity to be refered.
	 */
	public void setEntity(Entity entity){
		this.entity = entity;
	}

	/**
	 * Returns the name of the attribute.
	 * @return name of the attribute
	 */
	public String getName(){
		return entity.getName();
	}
}
