package ucot.parser;
import ucot.ModulePropertyInterface;
import ucot.input.UseCase;


//TODO comment the general usage of this interface better
//and other related tasks that the interface has to do

/**
 * Interface for parsers within this program.
 * Parsers are given usecase and they return ParsedData
 * @author vevijopi
 *
 */
public interface ParserInterface extends ModulePropertyInterface {
	/**
	 * Parses given usecase and returns parsed data as a ParsedData object.
	 * @param useCase Use case to parse.
	 * @return Parsed data as a ParsedData object.
	 */
	public ParsedData parse(UseCase useCase) throws Exception;
	
	/**
	 * Returns adapter's name.
	 * @return Adapter's name.
	 */
	public String getName();
	
}
