package ucot.parser;

import java.util.Properties;
import java.util.StringTokenizer;

import ucot.ModuleProperties;
import ucot.exceptions.BadPropertyValueException;
import ucot.input.UseCase;

//TODO comment me
public class SimpleInputParser extends ModuleProperties implements ParserInterface {
	
	public ParsedData parse(UseCase useCase) {
		if ( useCase == null ) return null;
		
		ParsedData pd = new ParsedData();
		pd.setUseCase(useCase);
		useCase.setParser(this);
		StringTokenizer st = null;
		Sentence sentence = null;
		Word word = null,subj = null,pred = null,obj = null;
		int count = 0;
		String wordClass = "noun";
		//Go through all use case steps
		for(int i=0;i<useCase.getStepCount();i++) {
			
			//Separate each word from the use case line
			st = new StringTokenizer(useCase.getStep(i).getStep(),",");
			sentence = new Sentence();
			
			count=0;
			
			//And go through them all
			while(st.hasMoreTokens()) {
				//there should only be 3 words
				if (count > 2) break;
				//Usually the words are noun
				wordClass = "noun";				
				//allthough the second word is always a verb
				if (count == 1) wordClass = "verb";
				
				//Create a word objcet from the text
				word = new Word(st.nextToken().trim().replace(".",""),wordClass);
				
				//And add it to our sentence
				sentence.addWord(word);				
				
				count++;
			}
			
			//There should be atleast 3 words, rest of them are ignored
			if (count > 2) {
				//In our simple input:			
				//First word is always subject			
				subj = sentence.getWords().get(0);
				//Second word is always predicate
				pred = sentence.getWords().get(1);
				//Third word is always object
				obj = sentence.getWords().get(2);
			}

			//Incase we didn't get 3 words, there should be no link and sentence shouldn't be added(?)
			if (null != subj && null != pred && null != obj){
				pred.addLink(new Link("subject",subj));
				pred.addLink(new Link("object",obj));
				
				pd.addSentence(sentence);
			}
			
			//Make sure the next sentence doesn't use our words 
			subj = null;
			pred = null;
			obj = null;
			
		}
		
		return pd;
	}

	
	public String getName() {		
		return "Simple input parser";
	}
    
    public String toString() {
        return this.getName();
    }
	
	/* (non-Javadoc)
	 * @see ucot.ModulePropertyInterface#loadDefaultProperties()
	 */
	public Properties loadDefaultProperties() {
		Properties result = super.loadDefaultProperties();
		// TODO Set default properties here, for example:
		// result.setProperty("SETTING_1", "Woot");
		// result.setProperty("SETTING_2", "WTF?");
		return result;
	}

	/* (non-Javadoc)
	 * @see ucot.ModulePropertyInterface#applyProperties()
	 */
	public void applyProperties() throws BadPropertyValueException {
		// TODO Auto-generated method stub
		
	}
	
}
