package ucot.ui.gui;

import java.awt.FlowLayout;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;

/**
 * Statusbar component for Swing. This class is inherited from JPanel
 * and simply uses flow layout to insert components to the bar.
 * @author UCOT
 */
public class Statusbar extends JPanel {
	
	private static final long serialVersionUID = -7570976997422611985L;

	/**
	 * Default constructor for statusbar. This
	 * method initializes the statusbar with the correct layout.
	 */
	public Statusbar() {
		super();
		this.setLayout(new FlowLayout(FlowLayout.TRAILING, 0, 0));
	}
	
	/**
	 * Method for adding columns to the statusbar.
	 * @param component Component to be added to the statusbar.
	 */
	public void addColumn(JComponent component) {
		component.setBorder(new BevelBorder(BevelBorder.LOWERED));
		add(component);
	}
}