package ucot.ui.gui.dialog.entitytab;

import java.util.Set;

import javax.swing.JComponent;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

import ucot.model.AnalyzeModel;
import ucot.ui.gui.GUIUtils;

//TODO comment me
public abstract class JTableEntityPropertiesTab extends JTableAndButtonsPanel implements EntityPropertiesTab {

	
	DefaultTableModel tableModel = new DefaultTableModel();
	String[] columnNames;
	String tabName;
	public JTableEntityPropertiesTab(String name, String[] columnNames){
		tabName = name;
		this.columnNames = columnNames;
		getTable().setModel(tableModel);
	}
	
	
	public String getTabName() {
		return tabName;
	}


	public DefaultTableModel getModel(){
		return tableModel;
	}	
	public void clear(){
//		 Erase all data from old table models.
		for ( int i = tableModel.getRowCount()-1; i >= 0; i-- )
			tableModel.removeRow(i);
	};
	
	public void updateCellEditor(AnalyzeModel analyzeModel, String entityName, int column_index, boolean allowSelf){
		Set<String> entities = analyzeModel.getEditor().getEntityNames();
		String[] entitiesArray = new String[entities.size()];
		entitiesArray = entities.toArray(entitiesArray);
		TableColumn column = getTable().getColumnModel().getColumn(column_index);
		column.setCellEditor(GUIUtils.createComboBoxCellEditor(entitiesArray,entityName,SELF_POINTER_NAME,allowSelf, true));
	}
	
	
	public void setColumns(String[] columnNames){
		this.columnNames = columnNames;
		getModel().setColumnCount(columnNames.length);
		getModel().setColumnIdentifiers(columnNames);	
	}
	public void load(AnalyzeModel analyzeModel, String entityName){
		setColumns(columnNames);
	};
	public void save(AnalyzeModel model, String entityName){}

	

	public JComponent getComponent() {
		return this;
	};

}
